Codeforces 835C

来源:互联网 发布:张琪格的淘宝店 编辑:程序博客网 时间:2024/06/05 14:57
C. Star sky
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

The Cartesian coordinate system is set in the sky. There you can see n stars, the i-th has coordinates (xiyi), a maximum brightness c, equal for all stars, and an initial brightness si (0 ≤ si ≤ c).

Over time the stars twinkle. At moment 0 the i-th star has brightness si. Let at moment t some star has brightness x. Then at moment (t + 1) this star will have brightness x + 1, if x + 1 ≤ c, and 0, otherwise.

You want to look at the sky q times. In the i-th time you will look at the moment ti and you will see a rectangle with sides parallel to the coordinate axes, the lower left corner has coordinates (x1iy1i) and the upper right — (x2iy2i). For each view, you want to know the total brightness of the stars lying in the viewed rectangle.

A star lies in a rectangle if it lies on its border or lies strictly inside it.

Input

The first line contains three integers nqc (1 ≤ n, q ≤ 1051 ≤ c ≤ 10) — the number of the stars, the number of the views and the maximum brightness of the stars.

The next n lines contain the stars description. The i-th from these lines contains three integers xiyisi (1 ≤ xi, yi ≤ 1000 ≤ si ≤ c ≤ 10) — the coordinates of i-th star and its initial brightness.

The next q lines contain the views description. The i-th from these lines contains five integers tix1iy1ix2iy2i (0 ≤ ti ≤ 1091 ≤ x1i < x2i ≤ 1001 ≤ y1i < y2i ≤ 100) — the moment of the i-th view and the coordinates of the viewed rectangle.

Output

For each view print the total brightness of the viewed stars.

Examples
input
2 3 31 1 13 2 02 1 1 2 20 2 1 4 55 1 1 5 5
output
303
input
3 4 51 1 22 3 03 3 10 1 1 100 1001 2 2 4 42 2 1 4 71 50 50 51 51
output
3350
Note

Let's consider the first example.

At the first view, you can see only the first star. At moment 2 its brightness is 3, so the answer is 3.

At the second view, you can see only the second star. At moment 0 its brightness is 0, so the answer is 0.

At the third view, you can see both stars. At moment 5 brightness of the first is 2, and brightness of the second is 1, so the answer is 3.

思路:这题如果采用直接暴力法是肯定会TLE,所以应该才询问之前先统计一下各个位置同样亮度的星星有多少个,可以发现状态转移方程为dp[i][j][k]+=dp[i-1][j][k]+dp[i][j-1][k]-dp[i-1][j-1][k],然后就可以统计每种亮度的有多少个了。

代码:

#include <iostream>#include <stdio.h>#include <string.h>#include <algorithm>using namespace std;#define ll long long#define ma(a) memset(a,0,sizeof(a))int dp[105][105][11];int main(){    int n,q,c;    while(~scanf("%d%d%d",&n,&q,&c))    {        ma(dp);        int i,j,k;        for(i=0;i<n;i++)        {            int x,y,z;            scanf("%d %d %d",&x,&y,&z);            dp[x][y][z]++;        }        for(i=1;i<=100;i++)        {            for(j=1;j<=100;j++)            {                for(k=0;k<=c;k++)                {                    dp[i][j][k]+=dp[i-1][j][k]+dp[i][j-1][k]-dp[i-1][j-1][k];                }            }        }        while(q--)        {            ll t,sum=0;            int x1,x2,y1,y2;            cin>>t>>x1>>y1>>x2>>y2;            for(i=0;i<=c;i++)            {                int ans=(t+i)%(c+1);                sum+=(dp[x2][y2][i]+dp[x1-1][y1-1][i]-dp[x2][y1-1][i]-dp[x1-1][y2][i])*ans;            }            cout<<sum<<endl;        }    }    return 0;}